# $Revision: 1.8 $, $Date: 2011/02/24 18:49:43 $
# TODO:
# - rename to java-javassist (?)
# - it doesn't build with gcj, because it requires com.sun.jdi. Is there any
#   non-sun package that provides these classes?

%include	/usr/lib/rpm/macros.java
Summary:	Java Programming Assistant: bytecode manipulation
Summary(pl.UTF-8):	Asystent programisty Javy: operacje na bajtkodzie
Name:		javassist
Version:	3.14.0
Release:	1
License:	MPL and LGPL
Group:		Libraries/Java
Source0:	http://downloads.sourceforge.net/jboss/%{name}-%{version}-GA.zip
# Source0-md5:	a2d1b4421e3902554d333d009db852a8
URL:		http://www.csg.is.titech.ac.jp/~chiba/javassist/
BuildRequires:	ant >= 0:1.6
BuildRequires:	jdk
BuildRequires:	jpackage-utils >= 0:1.6
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.300
BuildRequires:	unzip
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Javassist (Java Programming Assistant) makes Java bytecode
manipulation simple. It is a class library for editing bytecodes in
Java; it enables Java programs to define a new class at runtime and to
modify a class file when the JVM loads it. Unlike other similar
bytecode editors, Javassist provides two levels of API: source level
and bytecode level. If the users use the source-level API, they can
edit a class file without knowledge of the specifications of the Java
bytecode. The whole API is designed with only the vocabulary of the
Java language. You can even specify inserted bytecode in the form of
source text; Javassist compiles it on the fly. On the other hand, the
bytecode-level API allows the users to directly edit a class file as
other editors.

%description -l pl.UTF-8
Javassist (asystent programisty Javy) ułatwia operacje na bajtkodzie
Javy. Jest to biblioteka klas do modyfikowania bajtkodu w Javie;
pozwala programom w Javie definiować nowe klasy w czasie działania
oraz modyfikować pliki klas w czasie wczytywania ich przez JVM. W
przeciwieństwie do innych podobnych edytorów bajtkodu Javassist
udostępnia dwa poziomy API: źródłowy i bajtkodu. Korzystający z API
poziomu źródłowego mogą modyfikować plik klasy bez znajomości
specyfikacji bajtkodu. Całe API jest zaprojektowane z użyciem
wyłącznie słownictwa języka Java. Można nawet określać wstawiany
bajtkod w postaci tekstu źródłowego - Javassist skompiluje go w locie.
Z drugiej strony API poziomu bajtkodu pozwala użytkownikom
bezpośrednio modyfikować pliki klas, tak jak inne edytory.

%package demo
Summary:	Samples for Javassist
Summary(pl.UTF-8):	Przykłady użycia Javassista
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description demo
Demonstrations and samples for Javassist.

%description demo -l pl.UTF-8
Pliki demonstracyjne i przykłady dla Javassista.

%package javadoc
Summary:	Javadoc for Javassista
Summary(pl.UTF-8):	Dokumentacja Javadoc do Javassista
Group:		Documentation

%description javadoc
Documentation for Javassist.

%description javadoc -l fr.UTF-8
Javadoc pour Javassist.

%description javadoc -l pl.UTF-8
Dokumentacja do Javassista.

%package manual
Summary:	Tutorial for Javassist
Summary(pl.UTF-8):	Podręcznik do Javassista
Group:		Documentation

%description manual
Tutorial for Javassist.

%description manual -l pl.UTF-8
Podręcznik do Javassista.

%prep
%setup -q -n %{name}-%{version}-GA
find -name '*.jar' | xargs rm -vf

%build
%ant dist

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d $RPM_BUILD_ROOT%{_javadir}
cp -a %{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

# demo
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -pr sample/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

# javadoc
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr html/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -nfs %{name}-%{version} %{_javadocdir}/%{name}

%files
%defattr(644,root,root,755)
%doc License.html Readme.html
%{_javadir}/*.jar

%files demo
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}

%files javadoc
%defattr(644,root,root,755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(644,root,root,755)
%doc tutorial

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: javassist.spec,v $
Revision 1.8  2011/02/24 18:49:43  pawelz
up to 3.14.0

Revision 1.7  2010/05/16 14:14:05  sparky
- BR: unzip

Revision 1.6  2010/04/23 00:03:45  pawelz
- Don't force specific jdk.

Revision 1.5  2009/09/21 22:59:10  pawelz
- G: Libraries/java
- TODO
- cosmetics

Revision 1.4  2009/09/21 22:54:10  pawelz
- up to 3.11.0
- per distro jdk bconds
- some BRs from template-specs/java.spec

Revision 1.3  2008/05/09 12:18:31  jajcus
- Release: 1
- %doc handling fixed (previously the /usr/share/doc/%{name}-%{version} directory was not packaged)

Revision 1.2  2008-01-14 21:59:01  qboosh
- pl

Revision 1.1  2007-12-02 18:41:47  glen
- new, based on jpackage
